package javax.smartcardio;

import java.util.Iterator;
import java.util.List;

public abstract class CardTerminals
{
    protected CardTerminals() {
    }
    
    public List<CardTerminal> list() throws CardException {
        return this.list(CardTerminals.State.ALL);
    }
    
    public abstract List<CardTerminal> list(CardTerminals.State p0) throws CardException;
    
    public CardTerminal getTerminal(String anObject) {
        if (anObject == null) {
            throw new NullPointerException();
        }
        try {
            for (CardTerminal cardTerminal : this.list()) {
                if (cardTerminal.getName().equals(anObject)) {
                    return cardTerminal;
                }
                continue;
            }
            return null;
        }
        catch (CardException ex) {
            return null;
        }
    }
    
    public void waitForChange() throws CardException {
        this.waitForChange(0L);
    }
    
    public abstract boolean waitForChange(long p0) throws CardException;
    
    public enum State
    {
        ALL, 
        CARD_PRESENT, 
        CARD_ABSENT, 
        CARD_INSERTION, 
        CARD_REMOVAL;
    }
}
